#!/usr/bin/env python


from I3Tray import *
import sys, os, glob
from icecube import icetray, dataclasses, dataio, filter_tools, phys_services
import filter_globals
from filter_globals import which_split
from OnlineFilter import OnlineFilter


sys.path.append("/data/user/i3filter/IC86_OfflineProcessing/OfflineProductionTools")
sys.path.append("/data/user/i3filter/SQLServers_n_Clients")

from RunTools import *
from DbTools import *
from FileTools import *


try:
    import SQLClient_dbs4 as dbs4
    dbs4_ = dbs4.MySQL()
    
except Exception, err:
    raise Exception("Error: %s "%str(err))



def make_parser():
    """Make the argument parser"""
    from optparse import OptionParser
    parser = OptionParser()
    
    parser.add_option("--job", action="store",
        type="int", default=None, dest="job",
        help="queue id, usually $args(procnum)")
    
    return parser 


#def main(params):
def main(options, stats={}):
    
    try:
        print "\n+++++++++++++++"


        sql = """SELECT * FROM i3filter.urlpath u where u.dataset_id=1877 and u.queue_id=%d """%(options['job'],)
        print sql
        oldRecords = dbs4_.fetchall(sql,UseDict=True)
       
        
        old_path = ''
        new_path = ''
        new_chk = None
        new_size = None
        old_size = None
        for row in oldRecords:
            if 'GCD' in row['name']:
                continue
            elif 'ReOnline' in row['name']:
                new_path = os.path.join(row['path'],row['name']).replace('file:','')
                new_chk = str(row['md5sum'])
                new_size = int(row['size'])
            else:
                old_path = os.path.join(row['path'],row['name']).replace('file:','')
                old_size = int(row['size'])
        
        
        if new_size < old_size:
            print 'new file size: ', new_size
            print 'old file size: ', old_size
            raise Exception('new file size should be >= old file size')
            
        
        #actual_chk = md5sum(new_path)
        FT = FileTools(new_path)
        actual_chk = str(FT.md5sum())
        if actual_chk != new_chk:
            print 'DB md5sum',new_chk
            print 'actual md5sum',actual_chk
            raise Exception('md5sum mismatch')
        
        cmd = "mv %s %s"%(new_path,old_path)
        print cmd
        os.system(cmd)
           
        sql = """UPDATE i3filter.urlpath u SET md5sum="%s", size=%d, transferstate="WAITING" where u.dataset_id=1874 and u.name="%s" """%(new_chk,new_size,os.path.basename(old_path))
        print sql
        dbs4_.execute(sql)

        
    except Exception, err:
        raise Exception("Error: %s "%str(err))
    



### iceprod stuff ###
try:
    from iceprod.modules import ipmodule
except ImportError, e:
    print 'Module iceprod.modules not found. Will not define IceProd Class'
else:
    def PostProcess():
        return ipmodule.FromOptionParser(make_parser(),main)
### end iceprod stuff ###
  
  
    
    
# the business!
if (__name__=="__main__"):

    from optparse import OptionParser

    parser = make_parser()
    
    (options,args) = parser.parse_args()
    opts = {}
    # convert to dictionary
    for name in parser.defaults:
        value = getattr(options,name)
        if name == 'infile' and ',' in value:
            value = value.split(',') # split into multiple inputs
        opts[name] = value

    print "\nArgument : Value"
    for k in opts:
        print k," : ",opts[k]
    
    main(opts)

